

// program launcher


#include "mainwin.h"
#include "resource.h"



void GetVersionString
  (PMAINWINCTX pCtx)
{
  DWORD 	    dwZ;
  DWORD 	    dwInfoSize;
  UINT		    uLen;
  void*             pInfo;
  VS_FIXEDFILEINFO* pVffi;
  LPTSTR            cmdLn;
  TCHAR 	    exeName[MAX_PATH];
  TCHAR*            scn;
  TCHAR		    cSepa;	

  cmdLn = GetCommandLine();

  if ('"' == (cSepa = cmdLn[0]))
  {
    cmdLn++;
  }
  else
  {
    cSepa = ' ';
  } 
  scn = cmdLn;

  do
  {
    if (*scn == cSepa) break;
    scn++;
  }
  while (*scn);

  lstrcpyn(exeName, cmdLn, (int)scn - (int)cmdLn + sizeof(TCHAR));

  dwInfoSize = GetFileVersionInfoSize(exeName, &dwZ);

  if (0 == dwInfoSize)
  {
    lstrcpy(pCtx->szVersion, "???");
    return;
  }

  pInfo = (void*) LocalAlloc(LMEM_FIXED, dwInfoSize);

  GetFileVersionInfo(exeName, 0, dwInfoSize, pInfo);

  VerQueryValue(pInfo,
                "\\",
                (void**) &pVffi,
                &uLen);

  wsprintf(pCtx->szVersion, 
           "%d.%02d.%02d.%03d",
	   pVffi->dwFileVersionMS >> 16,
           pVffi->dwFileVersionMS & 0x0ffff,
           pVffi->dwFileVersionLS >> 16,
           pVffi->dwFileVersionLS & 0x0ffff);

  LocalFree((HLOCAL) pInfo);
}




int WINAPI WinMain(HINSTANCE hInst,
                   HINSTANCE hPrevInst,
                   PSTR szCmdLine,
                   int nCmdShow) 
{
  PMAINWINCTX pCtx;
  HWND        hWnd;
  MSG         msg;
  HACCEL      hAccel;

  if (!MainWin_Init(hInst)) {

    return 0;
  }

  if (NULL == (pCtx = MainWin_Create(hInst))) {
      
    return 0;
  }

  GetVersionString(pCtx);

  hWnd = MainWin_GetHandle(pCtx);

  ShowWindow(hWnd, nCmdShow);
 
  UpdateWindow(hWnd);

  hAccel = LoadAccelerators(hInst, MAKEINTRESOURCE(IDR_ACC_MAINWIN));

  // handle command line stuff
  if (lstrlen(szCmdLine)) {
  
    MainWin_ExecFileHash(pCtx, szCmdLine);
  }

  while (GetMessage(&msg, NULL, 0, 0)) {

    if (!TranslateAccelerator(hWnd, hAccel, &msg)) { 
     
      TranslateMessage(&msg);
      DispatchMessage(&msg);
    }
  }

  MainWin_Destroy(pCtx);

  return msg.wParam;

}






